

   MEMBER('ListEmbeds.clw')                                ! This is a MEMBER module


   INCLUDE('ABASCII.INC'),ONCE
   INCLUDE('ABTOOLBA.INC'),ONCE
   INCLUDE('ABUTIL.INC'),ONCE
   INCLUDE('ABWINDOW.INC'),ONCE

                     MAP
                       INCLUDE('LISTEMBEDS001.INC'),ONCE        !Local module procedure declarations
                     END


Main PROCEDURE                                             ! Generated from procedure template - Window

parser              &TxaParserClass
q                   TxaProcedureQueue
TxaName              STRING(500)                           !
OutputFile           STRING(500)                           !
ViewerActive4        BYTE(False)
AsciiFilename4       STRING(FILE:MaxFilePath),AUTO,STATIC,THREAD
AsciiFile4           FILE,DRIVER('ASCII'),NAME(AsciiFilename4),PRE(A4),THREAD
RECORD                RECORD,PRE()
TextLine                STRING(255)
                      END
                     END
Window               WINDOW('List Embeds'),AT(,,365,283),FONT('Microsoft Sans Serif',8,,,CHARSET:DEFAULT),GRAY
                       PROMPT('File Name:'),AT(7,10),USE(?FileName:Prompt)
                       ENTRY(@s255),AT(49,10,261,10),USE(TxaName)
                       PROMPT('Output File:'),AT(7,26),USE(?OutputFile:Prompt)
                       STRING(@s255),AT(43,26,267,10),USE(OutputFile)
                       BUTTON('Go!'),AT(331,8,27,12),USE(?go)
                       LIST,AT(7,40,350,222),USE(?List),FROM(''),IMM
                       BUTTON('Close'),AT(148,266,67),USE(?Close)
                       BUTTON('...'),AT(315,8,12,12),USE(?LookupFile)
                     END

ThisWindow           CLASS(WindowManager)
Init                   PROCEDURE(),BYTE,PROC,DERIVED       ! Method added to host embed code
Kill                   PROCEDURE(),BYTE,PROC,DERIVED       ! Method added to host embed code
Reset                  PROCEDURE(BYTE Force=0),DERIVED     ! Method added to host embed code
TakeAccepted           PROCEDURE(),BYTE,PROC,DERIVED       ! Method added to host embed code
TakeFieldEvent         PROCEDURE(),BYTE,PROC,DERIVED       ! Method added to host embed code
TakeWindowEvent        PROCEDURE(),BYTE,PROC,DERIVED       ! Method added to host embed code
                     END

Toolbar              ToolbarClass
TxaViewer            AsciiViewerClass
FileLookup2          SelectFileClass

  CODE
  GlobalResponse = ThisWindow.Run()                        ! Opens the window and starts an Accept Loop

Viewer4:Initialize ROUTINE
  AsciiFilename4=OutputFile
  ViewerActive4=TxaViewer.Init(AsciiFile4,A4:Textline,AsciiFilename4,?List,GlobalErrors)
SetOutputFilename   ROUTINE
    if clip(txaname) = ''
        outputfile = ''
    else
        OutputFile = clip(TxaName) & '.embeds.txt'
    END
    display(?outputfile)
!---------------------------------------------------------------------------
DefineListboxStyle ROUTINE
!|
!| This routine create all the styles to be shared in this window
!| It`s called after the window open
!|
!---------------------------------------------------------------------------

ThisWindow.Init PROCEDURE

ReturnValue          BYTE,AUTO

  CODE
  GlobalErrors.SetProcedureName('Main')
  TxaName = IniMgr.TryFetch('Preference','TxaName')
  SELF.Request = GlobalRequest                             ! Store the incoming request
  ReturnValue = PARENT.Init()
  IF ReturnValue THEN RETURN ReturnValue.
  SELF.FirstField = ?FileName:Prompt
  SELF.VCRRequest &= VCRRequest
  SELF.Errors &= GlobalErrors                              ! Set this windows ErrorManager to the global ErrorManager
  SELF.AddItem(Toolbar)
  CLEAR(GlobalRequest)                                     ! Clear GlobalRequest after storing locally
  CLEAR(GlobalResponse)
  IF SELF.Request = SelectRecord
     SELF.AddItem(?Close,RequestCancelled)                 ! Add the close control to the window manger
  ELSE
     SELF.AddItem(?Close,RequestCompleted)                 ! Add the close control to the window manger
  END
  SELF.Open(Window)                                        ! Open window
  Do DefineListboxStyle
  INIMgr.Fetch('Main',Window)                              ! Restore window settings from non-volatile store
  FileLookup2.Init
  FileLookup2.ClearOnCancel = True
  FileLookup2.Flags=BOR(FileLookup2.Flags,FILE:LongName)   ! Allow long filenames
  FileLookup2.SetMask('TXAa','*.txa')                      ! Set the file mask
  SELF.SetAlerts()
  RETURN ReturnValue


ThisWindow.Kill PROCEDURE

ReturnValue          BYTE,AUTO

  CODE
  If Self.Response = RequestCompleted
     IniMgr.Update('Preference','TxaName',TxaName)
  End
  ReturnValue = PARENT.Kill()
  IF ReturnValue THEN RETURN ReturnValue.
  IF SELF.Opened
    INIMgr.Update('Main',Window)                           ! Save window data to non-volatile store
  END
  GlobalErrors.SetProcedureName
  RETURN ReturnValue


ThisWindow.Reset PROCEDURE(BYTE Force=0)

  CODE
  SELF.ForcedReset += Force
  IF Window{Prop:AcceptAll} THEN RETURN.
  IF ViewerActive4 THEN TxaViewer.TakeEvent(EVENT()).
  PARENT.Reset(Force)


ThisWindow.TakeAccepted PROCEDURE

ReturnValue          BYTE,AUTO

Looped BYTE
  CODE
  LOOP                                                     ! This method receive all EVENT:Accepted's
    IF Looped
      RETURN Level:Notify
    ELSE
      Looped = 1
    END
    CASE ACCEPTED()
    OF ?go
              parser &= new TxaParserClass()
              setcursor(cursor:wait)
              parser.SetQueue(q)
              parser.Reset()
              if parser.parse(TxaName)
                  if not parser.Write(OutputFile)
                      message('Unable to write output file: ' & parser.getlasterror())
                  END
              ELSE
                  message('Unable to parse txa: ' & parser.getlasterror())
              END
              do Viewer4:Initialize
              display()
              setcursor()
              dispose(parser)
              
    END
  ReturnValue = PARENT.TakeAccepted()
    CASE ACCEPTED()
    OF ?LookupFile
      ThisWindow.Update
      TxaName = FileLookup2.Ask(0)
      DISPLAY
    END
    RETURN ReturnValue
  END
  ReturnValue = Level:Fatal
  RETURN ReturnValue


ThisWindow.TakeFieldEvent PROCEDURE

ReturnValue          BYTE,AUTO

Looped BYTE
  CODE
  LOOP                                                     ! This method receives all field specific events
    IF Looped
      RETURN Level:Notify
    ELSE
      Looped = 1
    END
  CASE FIELD()
  OF ?TxaName
        do SetOutputFilename
  OF ?List
    IF ViewerActive4
      IF TxaViewer.TakeEvent(EVENT())=Level:Notify THEN CYCLE.
    END
  OF ?LookupFile
              do SetOutputFilename          
  END
  ReturnValue = PARENT.TakeFieldEvent()
    RETURN ReturnValue
  END
  ReturnValue = Level:Fatal
  RETURN ReturnValue


ThisWindow.TakeWindowEvent PROCEDURE

ReturnValue          BYTE,AUTO

Looped BYTE
  CODE
  LOOP                                                     ! This method receives all window specific events
    IF Looped
      RETURN Level:Notify
    ELSE
      Looped = 1
    END
    CASE EVENT()
    OF EVENT:CloseWindow
      IF ViewerActive4
        TxaViewer.Kill
        ViewerActive4=False
      END
    END
  ReturnValue = PARENT.TakeWindowEvent()
    RETURN ReturnValue
  END
  ReturnValue = Level:Fatal
  RETURN ReturnValue

